
#define MODULE
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>

#include <linux/cons.h>

#include <linux/rt_sched.h>
#include <linux/rt_fifo.h>

RT_TASK mytask;
RT_TASK mytask2;


/* t -- the fifo number */
void fun(int t) {
	int data = 0;
	while (1) {
		rt_fifo_put(t, (char *) &data, sizeof(data));
		data++;
		rt_task_wait();
	}
}


int init_module(void)
{
	RTIME now = rt_get_time();
	rt_task_init(&mytask, fun, 1, 3000, 4);
	rt_task_init(&mytask2, fun, 2, 3000, 5);
	rt_task_make_periodic(&mytask, now + 3000, 25000);
	rt_task_make_periodic(&mytask2, now + 30000, 40000);
	return 0;
}


void cleanup_module(void)
{
	rt_task_delete(&mytask);
	rt_task_delete(&mytask2);
}
