#include <rt_fifo.h>

#include <stdio.h>
#include <unistd.h>
#include <errno.h>

int buf1[10];
int buf2[10];

int main()
{
	int i;
	rt_fifo_create(1, 1000);
	rt_fifo_create(2, 1000);
	while(1) {
		if (rt_fifo_get(1, (char *) buf1, 10 * sizeof(int)) > 0) {
			printf("Task1:");
			for (i = 0; i < 10; i++) {
				printf("%d ", buf1[i]);
			}
			printf("\n");
		}
		if (rt_fifo_get(2, (char *) buf2, 10 * sizeof(int)) > 0) {
			printf("Task2:");
			for (i = 0; i < 10; i++) {
				printf("%d ", buf2[i]);
			}
			printf("\n");
		}


	}
	rt_fifo_destroy(1);
	rt_fifo_destroy(2);
	return 0;
}
